--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/testing2/danube_test.sh Tue Nov 20 13:42:32 2018 +0000
@@ -0,0 +1,99 @@
+#!/bin/bash
+
+# to make the script fail safely
+set -euo pipefail
+
+
+out=${1:-output}
+
+echo "" > $out
+
+echo "Below is the feedback for your submission danube.scala" >> $out
+echo "" >> $out
+
+
+# compilation tests
+
+function scala_compile {
+ (ulimit -t 30; JAVA_OPTS="-Xmx1g" scala "$1" 2>> $out 1>> $out)
+}
+
+# functional tests
+
+function scala_assert {
+ (ulimit -t 30; JAVA_OPTS="-Xmx1g" scala -i "$1" "$2" -e "" 2> /dev/null 1> /dev/null)
+}
+
+# purity test
+
+function scala_vars {
+ (egrep '\bvar\b|\breturn\b|\.par|ListBuffer|mutable' "$1" 2> /dev/null 1> /dev/null)
+}
+
+
+# var, .par return, ListBuffer test
+#
+echo "danube.scala does not contain vars, returns etc?" >> $out
+
+if (scala_vars danube.scala)
+then
+ echo " --> fail (make triple-sure your program conforms to the required format)" >> $out
+ tsts0=$(( 0 ))
+else
+ echo " --> success" >> $out
+ tsts0=$(( 0 ))
+fi
+
+### compilation test
+
+
+if [ $tsts0 -eq 0 ]
+then
+ echo "danube.scala runs?" >> $out
+
+ if (scala_compile danube.scala)
+ then
+ echo " --> success" >> $out
+ tsts=$(( 0 ))
+ else
+ echo " --> scala did not run danube.scala" >> $out
+ tsts=$(( 1 ))
+ fi
+else
+ tsts=$(( 1 ))
+fi
+
+### danube get_cvs_url tests
+
+if [ $tsts -eq 0 ]
+then
+ echo "danube.scala tests:" >> $out
+ echo " val movies_url = \"\"\"https://nms.kcl.ac.uk/christian.urban/movies.csv\"\"\"" >> $out
+ echo " get_csv_url(movies_url).length == 9742" >> $out
+
+ if (scala_assert "danube.scala" "danube_test1.scala")
+ then
+ echo " --> success" >> $out
+ else
+ echo " --> one of the tests failed" >> $out
+ fi
+fi
+
+### danube processing tests
+
+if [ $tsts -eq 0 ]
+then
+ echo " val good_ratings = process_ratings(ratings)" >> $out
+ echo " val movie_names = process_movies(movies)" >> $out
+ echo " " >> $out
+ echo " good_ratings.length == 48580 " >> $out
+ echo " movie_names.length == 9742 " >> $out
+
+ if (scala_assert "danube.scala" "danube_test2.scala")
+ then
+ echo " --> success" >> $out
+ else
+ echo " --> one of the tests failed" >> $out
+ fi
+fi
+